apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if do_backups %}
    backups.opsperator.io/driver: mysql
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: {{ mariadb_name }}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ mariadb_name }}
  name: {{ mariadb_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ mariadb_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ mariadb_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ mariadb_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ mariadb_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
      automountServiceAccountToken: false
      containers:
{% if (mysql_options | default([])) | length > 0 %}
      - args:
        - /usr/bin/run-mysqld
{% for opt in mysql_options %}
        - {{ opt }}
{% endfor %}
        env:
{% else %}
      - env:
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: MYSQL_DATABASE
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ mariadb_name }}
        - name: MYSQL_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ mariadb_name }}
        - name: MYSQL_ROOT_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-admin-password
              name: {{ mariadb_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ mariadb_name }}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='mariadb'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='mariadb'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 3306
          timeoutSeconds: 3
        name: mariadb
        ports:
        - containerPort: 3306
        readinessProbe:
          exec:
            command:
            - /bin/sh
            - '-i'
            - '-c'
            - MYSQL_PWD="$MYSQL_PASSWORD" mysql -h 127.0.0.1 -u $MYSQL_USER -D $MYSQL_DATABASE -e 'SELECT 1'
          failureThreshold: 6
          initialDelaySeconds: 5
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ cpu_limit }}"
            memory: "{{ memory_limit }}"
          requests:
            cpu: "{{ cpu_limit }}"
            memory: "{{ memory_limit }}"
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 3306
          timeoutSeconds: 3
{% endif %}
        volumeMounts:
        - mountPath: /var/lib/mysql
          name: db
{% if do_exporters %}
      - args:
        - --collect.auto_increment.columns
        - --collect.binlog_size
        - --collect.engine_innodb_status
        - --collect.global_status
        - --collect.global_variables
        - --collect.info_schema.processlist
        - --collect.info_schema.userstats
        - --collect.info_schema.innodb_cmp
        - --collect.info_schema.innodb_cmpmem
        - --collect.info_schema.innodb_metrics
        - --collect.info_schema.innodb_tablespaces
        - --collect.info_schema.query_response_time
        - --collect.info_schema.tables
        - --collect.info_schema.tables.databases='*'
        - --collect.info_schema.tablestats
        - --collect.perf_schema.eventsstatements
        - --collect.perf_schema.eventswaits
        - --collect.perf_schema.file_events
        - --collect.perf_schema.file_instances
        - --collect.perf_schema.indexiowaits
        - --collect.perf_schema.tableiowaits
        - --collect.perf_schema.tablelocks
        env:
        - name: DATA_SOURCE_HOST
          value: 127.0.0.1
        - name: DATA_SOURCE_PASS
          valueFrom:
            secretKeyRef:
              name: {{ mariadb_name }}
              key: database-admin-password
        - name: DATA_SOURCE_USER
          value: root
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
{% if do_triggers == False or (opsimages | json_query("[?name=='mysqlexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='mysqlexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 9113
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
{% else %}
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
{% endif %}
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 or k8s_flavor == 'kubernetes' %}
      nodeSelector:
{% if k8s_resource_nodes_selectors | length > 0 %}
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-database
{% endif %}
{% endif %}
      securityContext:
{% if rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
        runAsUser: 27
      terminationGracePeriodSeconds: {{ mariadb_termination_timeout | default(600) }}
      volumes:
      - name: db
        persistentVolumeClaim:
          claimName: {{ mariadb_name }}
{% if (do_triggers | default(False)) != False %}
  triggers:
{% if (opsimages | json_query("[?name=='mariadb'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - mariadb
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='mariadb'].short"))[0] }}
        namespace: {{ namespace }}
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='mysqlexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='mysqlexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
